#!/usr/bin/env bash

#set -o errexit
set -o nounset
#set -o pipefail
if [[ "${TRACE-0}" == "1" ]]; then
  set -o xtrace
fi

cd "$(dirname "$0")"

main ()
{
  declare -a colors=(red green blue)
  declare -i powers=0
  while read -r game; do
    declare -A colors_max=([red]=0 [green]=0 [blue]=0)
    stripped_game=$(sed 's/^Game [0-9]\+: //' <<< "${game}")
    IFS=';' read -r -a sets <<< "${stripped_game}"
    for (( i=0; i<${#sets[@]}; i++ )); do
      for color in "${colors[@]}"; do
        count=$(grep -o "[0-9]* ${color}" <<< "${sets[$i]}" | grep -o '[0-9]*')
        if [[ $count -gt ${colors_max[$color]} ]]; then
          colors_max[$color]=$count
        fi
      done
    done
    (( powers+=colors_max[red]*colors_max[green]*colors_max[blue] ))
  done < input.txt
  echo $powers
}

main
